/*

 reads values of analog inputs (0-5) of arduino board
 and vizualizes them as a graph

 */

// libraries
import processing.serial.*;
// serial connection
Serial port;
String message = null;
String elements[] = null;
// arduino
int[] sensorValues = new int[6];
// graphs
int distanceX = 110;
int distanceBottom = 40;
int graphWidth = 40;
color graphColor = color(255,255,255);
PFont fontGraph;

void setup() {

  // size
  size(800, 600);
  // no strokes
  noStroke();
  // Set the font and its size (in units of pixels)
  fontGraph = createFont("Ariel",12);
  textFont(fontGraph, 12);
  // print all available serial ports
  println(Serial.list());
  // init connection to arduino
  port = new Serial(this, Serial.list()[0], 9600);
sensorValues[0] = 40;
sensorValues[1] = 10;
sensorValues[2] = 210;
sensorValues[3] = 10;
sensorValues[4] = 150;
sensorValues[5] = 130;

noLoop();
}

void draw() {

  // clear background
  background(0);

  // draw bars with values of analog inputs
  for(int i=0; i<6; i++){
    // color
    fill(graphColor);
    // draw bar
    rect(i*distanceX+distanceX,height-distanceBottom,graphWidth,-sensorValues[i]/2);
    // draw text
    text(sensorValues[i], i*distanceX+distanceX, height-distanceBottom+20);
  }
}



int byte1 = 0;
int byte2 = 0;
int byte3 = 0;
int byte4 = 0;


float eps = 0.5; //filter time constant
float filter1 = 0.0 ;//filtered value
float filter2 = 0.0 ;// filtered value
float filter3 = 0.0; // filtered value
int rawValue [] = new int[16];  //each reading is built from 4 bytes , + 4 for the frame header
int  currentIndex = 0;
boolean frameStart = false;
boolean firstRead = false;

// Send Recieve data //
void serialEvent(Serial myPort) {
redraw();
  //try
  {
  if (firstRead)
  {
    currentIndex = 0;
    frameStart = false;
    firstRead = true;
  }
currentIndex++; //increment the current index value
//Shift a moving frame of the 4 last bytes to search for the next iteration's header '1234' (not characters, the numeric values)
/*byte1=byte2;
byte2=byte3;
byte3=byte4;
byte4 = myPort.read();     // read a byte from the serial port:




//Check for header
if ((byte1 == 1) & (byte2 == 2) & (byte3 == 3) & (byte4 == 4))
{
  println("frame caught");
  frameStart = true;
  //Here, it seems weird, but I will start my raw values at index = 0.  And I will have '1234' for the next frame iteration caught in this array which can be used to check for the frame header for the next iteration.
  currentIndex = 0;
}
/*
if(currentIndex == 11)
{
  //Process the data:
   int up_low1 = rawValue[0];
   int up_high1 = rawValue[1];
  int  down_low1 = rawValue[2];
  int  down_high1 = rawValue[3];
  int  up_low2 = rawValue[4];
  int  up_high2 = rawValue[5];
  int  down_low2 = rawValue[6];
  int  down_high2 = rawValue[7];
  int  up_low3 = rawValue[8];
  int  up_high3 = rawValue[9];
  int  down_low3 = rawValue[10];
 int   down_high3 = rawValue[11];
 int   up_value1 = 256*up_high1 + up_low1;
 int   down_value1 = 256*down_high1 + down_low1;
  int  up_value2 = 256*up_high2 + up_low2;
  int  down_value2 = 256*down_high2 + down_low2;
  int  up_value3 = 256*up_high3 + up_low3;
 int   down_value3 = 256*down_high3 + down_low3;
float    value1 = (up_value1 + (1023 - down_value1))/2.0;
 float   value2 = (up_value2 + (1023 - down_value2))/2.0;
float    value3 = (up_value3 + (1023 - down_value3))/2.0;


/* // The following is fron Neil's python script.  What does it do ?  
 x1 = int(.2*WINDOW + (.9-.2)*WINDOW*filter1/1023.0)
   x2 = int(.2*WINDOW + (.9-.2)*WINDOW*filter2/1023.0)
   x3 = int(.2*WINDOW + (.9-.2)*WINDOW*filter3/1023.0)
   canvas.itemconfigure("text1",text="%.1f"%filter1)
   canvas.itemconfigure("text2",text="%.1f"%filter2)
   canvas.itemconfigure("text3",text="%.1f"%filter3)
   canvas.coords('rect11',.2*WINDOW,.05*WINDOW,x1,.2*WINDOW)
   canvas.coords('rect12',x1,.05*WINDOW,.9*WINDOW,.2*WINDOW)
   canvas.coords('rect21',.2*WINDOW,.3*WINDOW,x2,.45*WINDOW)
   canvas.coords('rect22',x2,.3*WINDOW,.9*WINDOW,.45*WINDOW)
   canvas.coords('rect31',.2*WINDOW,.55*WINDOW,x3,.7*WINDOW)
   canvas.coords('rect32',x3,.55*WINDOW,.9*WINDOW,.7*WINDOW)  
   filter1 = (1-eps)*filter1 + eps*value1
   filter2 = (1-eps)*filter2 + eps*value2
   filter3 = (1-eps)*filter3 + eps*value3
  
  
 //Change bar graph heights and labels. 
 sensorValues[0] = int(value1);
 sensorValues[1] = int(value2);
 sensorValues[2] = int(value3);
}
*/

rawValue[currentIndex] = byte4;
println( byte4);
  }//end try
  // catch (Exception e) {
  //  println("Aww snap... Initialization exception");
//    decide what to do here
 // }  
 
}

